/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_DSTP                                                     */
/* Tabela : DESTPROD                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 05/07/2001 - Newton Neves dos Santos                                       */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_DSTP
BEFORE INSERT OR UPDATE OR DELETE
ON DESTPROD FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUDSTP := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDDESTPROD,0) <> NVL(:NEW.CDDESTPROD,0)) OR
         (NVL(:OLD.DSDESTPROD,0) <> NVL(:NEW.DSDESTPROD,0)) THEN
         :NEW.DTULTATUDSTP := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('DESTPROD', '', 'CDDESTPROD='||:OLD.CDDESTPROD||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE DESTPROD MODIFY DTULTATUDSTP DEFAULT SYSDATE
/
